#pragma once

enum class FLAG_CATEGORY
{
  DBG = 0,
  DBSTP = 1,
  DBDISP = 2,
  DBGRAPHIC = 3,
  STA = 4,
  STOP = 5,
  GRAPHIC = 6,
  DISP = 7,
  GAME = 8
};

// enum names come from RTTI inside steam ver
// value names come from debug ver
enum class DBG_FLAG
{
  CAMERA_MODE = 0,
  CAM_MODE_OBJ = 1,
  CAM_MODE_SCR = 2,
  TRAILER_CAPTURE_MODE = 3,
  DBG_EFFECT_SCRCAPMODE = 4,
  DBG_CAM_INFO_DISP = 5,
  DBG_DBCAM_INFO_DISP = 6,
  TOOL_MODE = 7,
  DBG_ESP_TOOL = 8,
  SOUND_TOOL = 9,
  DBG_GA_TOOL = 10,
  DBG_WINDOWCTL_NO_ABTN = 11,
  DBG_DBGSTRING_NODISP = 12,
  DBG_ERASE_SYSTEM_PAGE = 13,
  DBG_ERASE_MEMORY_MAP = 14,
  STEP_MODE = 15,
  STEP_ADVANCE = 16,
  DBG_SCREEN_CAPTURE = 17,
  DBG_DEBUG_ROOM_JUMP = 18,
  DEBUG_MENU_BTN_NO_R1 = 19,
  DBG_RELOAD_ON = 20,
  PROCESS_BAR_DISP = 21,
  PROCESS_BAR_NO_AVE = 22,
  DBG_NOUSE_MENU_BAR = 23,
  DBG_ESP_DEBUG_DISP = 24,
  DBG_ESP_SCREEN_NODISP = 25,
  DBG_ESP_MULTI_THREAD_OFF = 26,
  DBG_ESP_T_MULTI_THREAD_OFF = 27,
  DBG_PL_LOW_CUBE_MAP_CHECK = 28,
  DBG_MOT_CAM_OFF = 29,
  DBG_ESP_I_MULTI_THREAD_OFF = 30,
  DBG_ESP_TRANS_CREATE_ORDER_OFF = 31,
  DBG_CAM_VIEW_UNDER_COL_CK = 32,
  DBG_CAM_ADJUST_OFF = 33,
  DBG_STRONG_ATK_SP = 34,
  DBG_IN_CUBEMAP_CAPTURE_MODE = 35,
  DBG_PAD_REPLACE = 36,
  DBG_PAD_KEYBOARD = 37,
  DBG_BEHAVIOR_SINGLE = 38,
  DBG_OBJ_TRANS_SINGLE = 39,
  // 40
  DBG_DVD_TIME = 41,
  DBG_DVD_FAST_STARTUP = 42,
  DBG_DVD_TIME_RECORD = 43,
  DBG_HAP_DEVELOPMENT_MODE = 44,
  DBG_HAP_TEST = 45,
  DBG_HAP_TOOL_USE_MEMO = 46,
  DBG_PL_WEP_LV_CHG = 47,
  DBG_PLAYER_NO_DAMAGE = 48,
  DBG_PLAYER_INVINCIBLE = 49,
  DBG_PL_SLOW_MUGEN = 50,
  DBG_PL_GAUGE_MUGEN = 51,
  DBG_PL_FAST_MOVE = 52,
  DBG_PL_HP_1 = 53,
  DBG_PL_DIE = 54,
  DBG_PL_MUGEN_JUMP = 55,
  DBG_PL_LV_FIX = 56,
  DBG_PL_LV_CHG = 57,
  DBG_PL_9S_HACKING = 58,
  DBG_VARIABLE_FRAME_DISABLE = 59,
  DBG_SLOW_RATE_30 = 60,
  DBG_COUTINUOUS_COMBO = 61,
  DBG_PL_SP_WAIT_IGNORE = 62,
  DBG_PL_CAM_CHECK_HIT_ON = 63,
  DBG_EM_NO_DAMAGE = 64,
  DBG_EM_WAIT_MODE = 65,
  DBG_EM_INSTANT_DEATH = 66,
  DBG_EM_SELECT = 67,
  DBG_EM_STUN_MAX = 68,
  DBG_EM_MANY_DAMAGE = 69,
  DBG_EM_NO_STUN = 70,
  DBG_EM_NO_ATTACK = 71,
  DBG_EM_BRAND = 72,
  DBG_EM_CONTROLHACK = 73,
  DBG_EM_TEAM = 74,
  DBG_EM_LEVELUP_ESP = 75,
  DBG_EM_HACKING_REACTION_TEST = 76,
  DBG_EM_NO_CHANGE_REACTION = 77,
  DBG_NPC_SEDACTIVE = 78,
  DBG_PL_DAMAGE_TEST = 79,
  DBG_TOOL_SLOW_MODE = 80,
  DBG_SCR_SHOT_TOOL = 81,
  DBG_SCR_SHOT_CONSTANT = 82,
  DBG_SCR_SHOT_ESP_LIGHT = 83,
  DBG_SCR_SHOT_DISTANTVIEW = 84,
  DBG_STOP_TEX_READ = 85,
  DBG_NO_CAMERA_MOUSE = 86,
  // 87
  DBG_EM_EMP_TEST = 88,
  DBG_GI_TOOL = 89,
  DBG_PL_FRONT_CAPSULE_CK = 90,
  DBG_EVENT_TEST_DRAW = 91,
  DBG_SCENE_CAPTURE = 92,
  DBG_SCENE_CAPTURE_READY = 93,
  DBG_PL_WEP_LV_MAX = 94,
  DBG_PERMIT_STEP_MODE_USE_WND = 95,
  DBG_ONISHI = 96,
  DBG_WAGATSUMA = 97,
  DBG_WAGATSUMA_FLIGHT_UNIT = 98,
  DBG_CAM_MODE_028 = 99,
  DBG_BUDDY_OFF = 100,
  DBG_HACKING_ACCELERATION = 101,
  DBG_ITEM_TEST = 102,
  DBG_EM_DELAYED_VIRUS_TEST = 103,
  DBG_WAGATSUMA_JUMPHEIGHT_TEST = 104,
  DBG_WAGATSUMA_ONLYSEQ_2 = 105,
  DBG_WAGATSUMA_FLIGHTMODE_SPEED = 106,
  DBG_VIEW_MOT = 107,
  DBG_2B_BREAK = 108,
  DBG_ESPRAYCAST_IGNORE = 109,
  DBG_YASUI_HACK_AUTO_SHOOT = 110,
  DBG_OKABE = 111,
  DBG_RYOUICHI = 112,
  DBG_CAPTURE_WITH_UI = 113,
  DBG_MOUSEMODE_OFF = 114,
  DBG_KEYBOARDPAD_ON = 115,
  DBG_FILE_READ_LOG = 116,
  DBG_PLAYGO_TEST = 117,
  DBG_AUTO_JUMP_TEST_MODE = 118,
  DBG_HONDA = 119,
  DBG_YASUI_MINIMAP = 120,
  DBG_UI_NO_MODE_CHANGE = 121,
  DBG_HACK_PASSIVE = 122,
  DBG_UI_FILTER_BREAK = 123,
  DBG_AUTO_PLAY = 124,
  DBG_AUTO_PLAY_LOCAL = 125,
  DBG_STP_UPDATE_PAD = 126,
  DBG_UI_FILTER_EMP = 127,
  DBG_NOUSESPU_ESPJOBMOVESPU = 128,
  DBG_NOUSESPU_ESPJOBPRETRANSSPU = 129,
  DBG_NOUSESPU_MODELUPDATEPARTS_MTX = 130,
  DBG_NOUSESPU_MODELTRANS = 131,
  DBG_GPUBULLET_BITONICSORTCPU = 132,
  DBG_WASADADEBUG_0 = 133,
  DBG_WASADADEBUG_1 = 134,
  DBG_WASADADEBUG_2 = 135,
  DBG_EXPERRIENTSHADER_CHANGE = 136,
  DBG_WASADADEBUG_4 = 137,
  DBG_WASADADEBUG_5 = 138,
  DBG_WASADADEBUG_6 = 139,
  DBG_WASADADEBUG_7 = 140,
  // 141
  DBG_PL_HAIR_COLOR_TEST = 142,
  DBG_EFFECT_GPUBULLET_NO_SORT = 143,
  DBG_KAMAKAMI = 144,
  DBG_UI_DETAIL_LOG = 145,
  DBG_UI_NAMEENTRY = 146,
  DBG_UI_WIREFRAME = 147,
  DBG_UI_MASK_NODISP = 148,
  DBG_UI_GAUSS_NODISP = 149,
  DBG_UI_DISP_EXPGAUGE = 150,
  DBG_UI_PASSIVE_SKILL_ON = 151,
  DBG_UI_FISHLIST_COMPLETE = 152,
  DBG_UI_EMLIST_COMPLETE = 153,
  DBG_UI_TUTORIAL_OPEN = 154,
  DBG_UI_NOVEL_OPEN = 155,
  DBG_UI_VIEW_HEX = 156,
  DBG_UI_PADMODE_FORCE = 157,
  DBG_UI_SINGLE_UPDATE = 158,
  DBG_UI_SINGLE_TRANS = 159,
  DBG_STAFFROLL_DUMMY_DOWNLOAD = 160,
  DBG_TIME_CRUNCH = 161,
  DBG_DECORPSE_BODY = 162,
  DBG_9SCTRL_MODE_B = 163,
  DBG_UI_LOG = 164,
  DBG_3DMAP_VISIBLE = 165,
  DBG_AFTERCLEARANCE_DBMENU_ENABLE = 166,
  DBG_ADD_PLAYTIME_15MINUTES = 167,
  // 168
  DBG_PL_AUTO_PLAY = 169,
  DBG_PL_SHOT_PLANE_OFF = 170,
  DBG_PL_SHOT_PLANE_DISP = 171,
  DBG_PL_SHOT_PLANE_SCR_B = 172,
  DBG_PL_SHOT_PLANE_BATTLE_B = 173,
  DBG_EM_HP_DISP = 174,
  DBG_PL_HACKING_TEST = 175,
  // 176
  DBG_EVENTSKIP_FORCE = 177,
  DBG_PLAYRECORD_OPEN = 178,
  DBG_ESP_CHECK_MODE = 179,
  DBG_NOT_LIMIT_CORPSE_NUMBER = 180,
  DBG_NO_TIME_LIMIT_CHIP_EFFECT = 181,
  DBG_DISPLAY_CORPSE_PARAMETER = 182,
  DBG_SUPPLY_CHECK_ON = 183,
  DBG_TIME_CRUNCH_SUPPLY = 184,
  DBG_HAP_LEVEL_BIND = 185,
  DBG_SUPPORT_MSG_TW = 186,
  DBG_SUPPORT_MSG_KR = 187,
  DBG_NETWORK_MENU_ON = 188,
  DBG_CLEARFLAG_ON = 189,
  DBG_FISH_TEST = 190,
  DBG_CLEAR_COLOR_CUSTOM = 191,
  DBG_SOUND_WWISE_COMM = 192,
  DBG_SOUND_MUTE_MASTER = 193,
  DBG_SOUND_MUTE_SE = 194,
  DBG_SOUND_MUTE_BGM = 195,
  DBG_SOUND_MUTE_VOICE = 196,
  DBG_SOUND_MUTE_ENV = 197,
  DBG_SOUND_DISABLE_AREA = 198,
  DBG_SOUND_DISABLE_REFLECTION = 199,
  DBG_SOUND_OFF_SE_CULL = 200,
  DBG_SOUND_NON_VOLATILE = 201,
  // 202
  // 203
  // 204
  // 205
  // 206
  DBG_UNSTABLE_SLOW_RATE = 207,
  DBG_EFFECT_AUTODIECHECK = 208,
  DBG_EFFECT_HITEFFECT_AUTO = 209,
  DBG_DLC00_MOUNT = 210,
  DBG_DLC01_MOUNT = 211,
  DBG_DLC02_MOUNT = 212,
  DBG_DLC03_MOUNT = 213,
  DBG_DLC04_MOUNT = 214,
  DBG_DLC05_MOUNT = 215,
  DBG_DLC06_MOUNT = 216,
  DBG_DLC07_MOUNT = 217,
  DBG_DLC08_MOUNT = 218,
  DBG_DLC09_MOUNT = 219,
  DBG_DLC10_MOUNT = 220,
  DBG_DLC11_MOUNT = 221,
  DBG_DLC12_MOUNT = 222,
  // 223
  DBG_LOW_MAP_DISABLE = 224,
  DBG_MANUAL_CULLING_DISABLE = 225,
  DB_LOW_MAP_ONLY = 226,
  // 227
  DBG_USE_QA_LEADERBORAD = 228,
  DBG_SET_UPLOAD_7DAY_IN_AVANCE = 229,
  DBG_SET_UPLOAD_60DAY_IN_AVANCE = 230,
  DBG_2B_SETUP_1MIN = 231,
  DBG_FASTTRAVEL_TEST = 232,
  DBG_SET_ALL_WEAPON = 233,
  DBG_SET_ALL_ACTIVESKILL = 234,
  DBG_PASSIVESKILL_TEST = 235,
  DBG_FASTTRAVEL_OLD = 236,
  DBG_MAILBOX_TEST = 237,
  DBG_QUEST_TEST = 238,
  DBG_TITLE_TEST = 239,
  DBG_BGM_HOLY_EFX = 240,
  DBG_BGM_CHORUS_EFX = 241,
  DBG_BGM_PITCH_SHIFT_P = 242,
  DBG_BGM_PITCH_SHIFT_M = 243,
  DBG_BGM_TIME_STRETCH_SLOW = 244,
  DBG_BGM_8BIT_TEST = 245,
  DBG_BGM_RECORD_EFX = 246,
  DBG_BGM_TRY_VOCAL_ON = 247,
  DBG_BGM_POD_TEMPO_SCALING = 248,
  // 249
  // 250
  // 251
  // 252
  // 253
  // 254
  // 255
};

enum class DBSTP_FLAG
{
  DBSTP_OBJ = 0,
  DBSTP_PL = 1,
  DBSTP_EM = 2,
  DBSTP_ETC = 3,
  DBSTP_ESP = 4,
  DBSTP_SCR = 5,
  DBSTP_UI = 6,
  DBSTP_FILTER = 7,
  DBSTP_SHADOW = 8,
  DBSTP_SUBPL = 9,
  DBSTP_PAD_VIB = 10,
  DBSTP_LAYOUT_SET = 11,
  // 12
  // 13
  // 14
  // 15
  DBSTP_ATDMHIT = 16,
  DBSTP_OBJHIT = 17,
  DBSTP_SCRHIT = 18,
  DBSTP_SCENARIO = 19,
  DBSTP_EVENT = 20,
  DBSTP_CLOTH_CALC_OFF = 21,
  DBSTP_CAMERA = 22,
  DBSTP_LIGHT = 23,
  DBSTP_SCE_AT = 24,
  DBSTP_HAP_DISP = 25,
  DBSTP_IK = 26,
  DBSTP_GPU_BULLET = 27,
  // 28
  // 29
  // 30
  // 31
  DBSTP_ALLHIT = 32,
  DBSTP_ALL_MODEL = 33,
  DBSTP_SCENE = 34,
  // 35
  // 36
  DBSTP_ESPCALL = 37,
  // 38
  DBSTP_KEYBORED_SHORTCUT = 39,
  // 40
  // 41
  // 42
  // 43
  // 44
  // 45
  // 46
  // 47
  DBSTP_MODEL_WIND_RECEIVE = 48,
  DBSTP_FOOT_IK = 49,
  DBSTP_DEBUG_LOG = 50,
  // 51
  DBSTP_WND_WINDOW_SYSTEM = 52,
  DBSTP_ANIM = 53,
  DBSTP_UPDATE_VFCUL = 54,
  // 55
  DBSTP_STEP_MODE = 56,
  DBSTP_CALC_ROUTE = 57,
  DBSTP_HAP_SCENARIO = 58,
  DBSTP_HAP_LAZY_MOUNT = 59,
  // 60
  // 61
  // 62
  // 63
  DBSTP_POD_SUSPEND = 64,
  // 65
  // 66
  // 67
  // 68
  // 69
  // 70
  // 71
  // 72
  // 73
  // 74
  // 75
  // 76
  // 77
  // 78
  // 79
  DBSTP_MAP_UPDATE = 80,
  DBSTP_MODEL_TREE_OFF = 81,
  // 82
  // 83
  // 84
  // 85
  // 86
  // 87
  // 88
  // 89
  // 90
  // 91
  // 92
  // 93
  // 94
  // 95
  // 96
  // 97
  // 98
  // 99
  // 100
  // 101
  // 102
  // 103
  // 104
  // 105
  // 106
  // 107
  // 108
  // 109
  // 110
  // 111
  // 112
  // 113
  // 114
  // 115
  // 116
  // 117
  // 118
  // 119
  // 120
  // 121
  // 122
  // 123
  // 124
  // 125
  // 126
  // 127
};

enum class DBDISP_FLAG
{
  DBDISP_OBJ_NO_DISP = 0,
  DBDISP_PL_NO_DISP = 1,
  DBDISP_EM_NO_DISP = 2,
  DBDISP_ETCOBJ_NO_DISP = 3,
  DBDISP_ESP_NO_DISP = 4,
  DBDISP_SCR_NO_DISP = 5,
  DBDISP_UI_NO_DISP = 6,
  DBDISP_FILTER_NO_DISP = 7,
  DBDISP_SHADOW_NO_DISP = 8,
  DBDISP_DBPRIM_NO_DISP = 9,
  DBDISP_LIGHT_NO_DISP = 10,
  DBDISP_WP_NO_DISP = 11,
  DBDISP_BGOBJ_NO_DISP = 12,
  DBDISP_BAOBJ_NO_DISP = 13,
  DBDISP_BHOBJ_NO_DISP = 14,
  DBDISP_SCOBJ_NO_DISP = 15,
  DBDISP_ATDM_HIT_DISP = 16,
  DBDISP_OBJ_HIT_DISP = 17,
  DBDISP_SCR_HIT_DISP = 18,
  DBDISP_SCE_AT_DISP = 19,
  DBDISP_FILTER_ATDISP = 20,
  DBDISP_CUBEMAP_ATDISP = 21,
  DBDISP_INSTANCINGREGION = 22,
  DBDISP_DRAW_TEST = 23,
  DBDISP_MOTION_BLUR = 24,
  DBDISP_BEHAVIOR_INFO = 25,
  DBDISP_GA_ATARI_DISP = 26,
  DBDISP_PHASEINFO = 27,
  DBDISP_GAMEFLAG = 28,
  DBDISP_CAMERA = 29,
  DBDISP_CHARAPROXY = 30,
  DBDISP_BEHAVIOR_SCR_HIT_DISP = 31,
  DBDISP_CAM_ALPHA_VOLUME = 32,
  DBDISP_NO_DISP_HAP_LAYOUT = 33,
  DBDISP_1BM_OFF = 34,
  DBDISP_LOD_BOUNDING_VOULME = 35,
  DBDISP_BOUNDING_VOULME = 36,
  DBDISP_DIST_DISP = 37,
  DBDISP_WET_CHECK = 38,
  DBDISP_NO_DISP_PL_DM = 39,
  DBDISP_NO_DISP_EM_DM = 40,
  DBDISP_NO_DISP_PL_AT = 41,
  DBDISP_NO_DISP_EM_AT = 42,
  DBDISP_SHADE_COL_DISP = 43,
  DBDISP_BLEND_CHECK = 44,
  DBDISP_ANIMATIONNAME_DISP = 45,
  DBGDISP_IK = 46,
  DBGDISP_ROUTE = 47,
  DBDISP_EM_CAM_DIS = 48,
  DBDISP_PL_SEQ_FLAG_DISP = 49,
  DBDISP_ETC_CAM_DIS = 50,
  DBDISP_OBJ_ID = 51,
  DBDISP_SHADER_SETTING_INFO = 52,
  DBDISP_SHADER_SETTING_LIST = 53,
  DBDISP_EM_BEZIERCURVE = 54,
  DBDISP_SHADER_SETTING_MODEL = 55,
  DBDISP_FRAME_RATE_EMERGENCY = 56,
  DBDISP_FISHING_AREA = 57,
  DBDISP_CLOTH = 58,
  DBDISP_LIGHT = 59,
  DBDISP_MAKER = 60,
  DBDISP_PARTSSPRING = 61,
  DBDISP_PARTS_INFO = 62,
  DBDISP_PARTS_INFO_SPECIAL = 63,
  DBDISP_POLYGON_OCCLUDER = 64,
  DBDISP_NO_DRAW_ZMAP = 65,
  DBDISP_DOF_OFF = 66,
  DBDISP_FOG_NO_DISP = 67,
  DBDISP_SHADOW_MODEL_DISP = 68,
  DBDISP_SSLB_OFF = 69,
  DBDISP_SSAO_OFF = 70,
  DBDISP_AMBIENT_OFF = 71,
  DBDISP_MEM_WORK = 72,
  DBDISP_MEM_BUFFER = 73,
  DBDISP_MEM_FILE = 74,
  DBDISP_MEM_TEXTURE = 75,
  DBDISP_MEM_DEBUG = 76,
  DBDISP_MEM_GPURWBUFFER = 77,
  DBDISP_VLE_OFF = 78,
  DBDISP_TONEMAP_EXPOSURE = 79,
  DBDISP_ESP_WORK = 80,
  DBDISP_ESP_DEBUG = 81,
  DBDISP_ESP_LEDBG_EM_AUTO_REQUESTNSFLARE_DISP = 82,
  DBDISP_ESP_LIGHT_DISP = 83,
  DBDISP_ESP_LIGHT_OFF = 84,
  DBDISP_ESP_MODEL_OFF = 85,
  DBDISP_ESP_NO_MODEL_OFF = 86,
  DBDISP_ESP_AUTOALPHA_MAX1 = 87,
  DBDISP_ESP_AUTOALPHA_MAX2 = 88,
  DBDISP_ESP_HI_PRIORITY = 89,
  DBDISP_ESP_LENSFLARE_OFF = 90,
  DBDISP_ESP_DEBUG_ROOM_ONLY = 91,
  DBDISP_ESPSST_ATDISP = 92,
  DBDISP_EFFECT_SCRSET_AREA = 93,
  DBDISP_ESP_GPUPARTICLE_OFF = 94,
  DBDISP_ESP_EVENT_ONLY = 95,
  DBDISP_ESP_LINECHECK = 96,
  DBDISP_ESP_PROFILE = 97,
  DBDISP_ESP_2D_OFF = 98,
  DBDISP_ESP_SHELLPOLYGON_OFF = 99,
  DBDISP_ESP_RESOLVE_OFF = 100,
  DBDISP_ESP_BLUR_OFF = 101,
  DBDISP_ESP_CULL_SPHERE = 102,
  DBDISP_ESP_OCCLUSION_RATE = 103,
  DBDISP_ESP_STRIP_OFF = 104,
  DBDISP_ESP_AUTOSHADER_OFF = 105,
  DBDISP_ESP_CUSTOMSHADER_OFF = 106,
  DBDISP_ESP_CAPTURE_NO_DISP = 107,
  DBDISP_ESP_EXPOSURE_OFF = 108,
  DBDISP_EFFECT_EXTERNALFACTOR_DEBUG = 109,
  DBDISP_EFFECT_SHADERBUFFER_DDEBUG = 110,
  DBDISP_CAMERA_MARKER_OFF = 111,
  DBDISP_SOUND_AREA_SE = 112,
  DBDISP_SOUND_AREA_EFFECT = 113,
  DBDISP_SOUND_AREA_BGM = 114,
  DBDISP_SOUND_SE_OBJECT = 115,
  DBDISP_SOUND_SE_DISTANCE = 116,
  DBDISP_SOUND_INFO = 117,
  DBDISP_SOUND_ANYTIME_METER = 118,
  DBDISP_SOUND_STREAM_LOG = 119,
  // 120
  // 121
  // 122
  DBDISP_SOUND_VOICE_CALL = 123,
  DBDISP_SOUND_CHARA_TYPE = 124,
  DBDISP_SOUND_MATERIAL_GRAPH = 125,
  DBDISP_SOUND_MAP_HEX = 126,
  DBDISP_SOUND_SAMPLE_SPECTRUM = 127,
  DBDISP_REGIONAL_AREA_DISP = 128,
  DBDISP_CELESTIAL_OFF = 129,
  // 130
  // 131
  // 132
  // 133
  // 134
  // 135
  // 136
  // 137
  // 138
  // 139
  // 140
  // 141
  DBDISP_POINTLIGHT_OFF = 142,
  DBDISP_SPOTLIGHT_OFF = 143,
  // 144
  // 145
  // 146
  // 147
  // 148
  // 149
  // 150
  // 151
  // 152
  // 153
  // 154
  // 155
  // 156
  // 157
  // 158
  // 159
  DBDISP_UI_HUD_25D_OFF = 160,
  DBDISP_UI_FILTER_OFF = 161,
  // 162
  // 163
  // 164
  // 165
  // 166
  // 167
  // 168
  // 169
  // 170
  // 171
  // 172
  // 173
  // 174
  // 175
  // 176
  // 177
  // 178
  // 179
  // 180
  // 181
  // 182
  // 183
  // 184
  // 185
  // 186
  // 187
  // 188
  // 189
  // 190
  // 191
  DBDISP_SCR_HIT_AABB_DISP = 192,
  DBDISP_SCR_HIT_COL_WNO_DISP = 193,
  DBDISP_SCR_HIT_CURRENT_DISP = 194,
  DBDISP_SCR_HIT_COL_CK_DISP = 195,
  DBDISP_DRAW_MAP_HEX = 196,
  DBDISP_MANUAL_CULLING_PL = 197,
  DBDISP_EVENT_CAPTURE = 198,
  // 199
  // 200
  // 201
  // 202
  // 203
  // 204
  // 205
  // 206
  // 207
  // 208
  // 209
  // 210
  // 211
  // 212
  // 213
  // 214
  // 215
  // 216
  // 217
  // 218
  // 219
  // 220
  // 221
  // 222
  // 223
};

enum class DBGRAPHIC_FLAG
{
  DBGRAPHIC_SIMPLE_GRAPHIC = 0,
  DBGRAPHIC_SIMPLE_SHADER = 1,
  DBGRAPHIC_SHADER_PERFORMANCE = 2,
  DBGRAPHIC_HIGH_LOD_FIXED = 3,
  DBGRAPHIC_LOW_LOD_FIXED = 4,
  DBGRAPHIC_TEXTURE_LV_CK = 5,
  DBGRAPHIC_TEXTURE_DENSITY_CK = 6,
  DBGRAPHIC_GLARE_DISP = 7,
  DBGRAPHIC_SCREEN_FRAME = 8,
  DBGRAPHIC_NO_ANISO = 9,
  DBGRAPHIC_4_ANISO = 10,
  DBGRAPHIC_MIP_MAX_ON = 11,
  DBGRAPHIC_STP_SHADOWCAM_VFCUL = 12,
  DBGRAPHIC_EFFECTSHADER_PERFORMANCE = 13,
  DBGRAPHIC_CUTMODEL_STENCIL_VIEW = 14,
  DBGRAPHIC_LOD_DRAW = 15,
  DBGRAPHIC_DRAW_ALPHA_ONLY = 16,
  DBGRAPHIC_DRAW_PUNCH_ONLY = 17,
  DBGRAPHIC_DRAW_SHADOW_CAST = 18,
  DBGRAPHIC_DRAW_SHADOW_REC = 19,
  DBGRAPHIC_DRAW_BLUR_MODEL = 20,
  DBGRAPHIC_WIRE_FRAME_MODE = 21,
  // 22
  // 23
  // 24
  // 25
  // 26
  // 27
  // 28
  // 29
  // 30
  // 31
  DBGRAPHIC_NODRAW_SHADOW_CAST = 32,
  DBGRAPHIC_NODRAW_SHADOW_RCV = 33,
  DBGRAPHIC_NODRAW_MODEL_OT = 34,
  DBGRAPHIC_NODRAW_DEFERRED = 35,
  DBGRAPHIC_NODRAW_PRESORT3D = 36,
  DBGRAPHIC_NODRAW_RESOLVEAFTER3D = 37,
  DBGRAPHIC_NODRAW_SORT3D = 38,
  // 39
  // 40
  // 41
  // 42
  // 43
  // 44
  // 45
  // 46
  // 47
  DBGRAPHIC_NODRAW_SORT3D_2 = 48, // note: dupe of SORT3D above, added _2 suffix after extracting
  DBGRAPHIC_DEFERRED_OFF = 49,
  DBGRAPHIC_G_BUFFER_CLEAR = 50,
  DBGRAPHIC_GA_AREA_OFF = 51,
  DBGRAPHIC_VARIABLE_RESOLUTION_LV1 = 52,
  DBGRAPHIC_VARIABLE_RESOLUTION_LV2 = 53,
  DBGRAPHIC_VARIABLE_RESOLUTION_LV3 = 54,
  // 55
  DBGRAPHIC_MODEL_QUERY_OFF = 56,
  DBGRAPHIC_MODEL_QUERY_KEEP = 57,
  // 58
  // 59
  // 60
  // 61
  // 62
  // 63
  DBGRAPHIC_SSLBMAP_DISP = 64,
  DBGRAPHIC_SSAOMAP_DISP = 65,
  DBGRAPHIC_GI_OFF = 66,
  DBGRAPHIC_GI_SPHERE_DISP = 67,
  DBGRAPHIC_GI_ONLY = 68,
  DBGRAPHIC_GI_KYOUSEI_UPDATE = 69,
  DBGRAPHIC_AIR_SCATTERING_OFF = 70,
  DBGRAPHIC_SAFETYNET_START = 71,
  // 72
  DBGRAPHIC_TEXTURE_BLUR = 73,
  DBGRAPHIC_HDAO_OFF = 74,
  DBGRAPHIC_TEXTURE_BLUR_CAM_ON = 75,
  DBGRAPHIC_HISTOGRAM_ON = 76,
  DBGRAPHIC_TEXTURE_SIZE = 77,
  DBGRAPHIC_NOAA_RESOLUTION = 78,
  DBGRAPHIC_SHADER_TEST = 79,
  DBGRAPHIC_ALBEDO_SHADER = 80,
  DBGRAPHIC_NORMAL_SHADER = 81,
  DBGRAPHIC_NORMAL_TEX_SHADER = 82,
  DBGRAPHIC_COLOR_SHADER = 83,
  DBGRAPHIC_COLOR_ALPHA_SHADER = 84,
  DBGRAPHIC_UV_SHADER = 85,
  DBGRAPHIC_TANGENT_SHADER = 86,
  DBGRAPHIC_NO_LIGHTMAP = 87,
  DBGRAPHIC_NO_ALBEDO = 88,
  DBGRAPHIC_CUBE_MAP_GLAY = 89,
  DBGRAPHIC_LIGHTMAP_ONLY = 90,
  // 91
  // 92
  // 93
  // 94
  // 95
  DBGRAPHIC_DIST_LOST_OFF = 96,
  DBGRAPHIC_FAR_LOST_80M = 97,
  DBGRAPHIC_FAR_LOST_40M = 98,
  DBGRAPHIC_OCCLUDER_NO_DRAW = 99,
  DBGRAPHIC_GA_KEEP_EXIT = 100,
  DBGRAPHIC_HI_RESOLUTION = 101,
  DBGRAPHIC_MID_RESOLUTION = 102,
  DBGRAPHIC_SHADOW_NEWCULL_OFF = 103,
  DBGRAPHIC_DISP_STOP_SCR = 104,
  // 105
  // 106
  // 107
  DBGRAPHIC_OBJ_SHADOW_RECEIVE_OFF = 108,
  DBGRAPHIC_CAM_FAR_LONG = 109,
  // 110
  // 111
  DBGRAPHIC_LOD_SHADER_UPDATE = 112,
  DBGRAPHIC_LOD_NORMAL_OFF = 113,
  DBGRAPHIC_LOD_CUBEMAP_OFF = 114,
  DBGRAPHIC_LOD_SPECULAR_OFF = 115,
  DBGRAPHIC_LOD_LEVEL2 = 116,
  DBGRAPHIC_LOD_LEVEL3 = 117,
  // 118
  // 119
  // 120
  // 121
  DBGRAPHIC_ENL_IRRADIANCE_CUBE = 122,
  // 123
  // 124
  // 125
  // 126
  // 127
  DBGRAPHIC_TOOL_WRITE_OFF = 128,
  DBGRAPHIC_MTX_NO_UPDATE = 129,
  DBGARPHIC_ENLIGHTEN_TEXTURE_SHOT = 130,
  DBGRAPHIC_FORCE_PREEFF_RESOLVE = 131,
  DBGRAPHIC_EFFECTSHADER_DOWNGRADE = 132,
  DBGRAPHIC_BUFFERCLEAR_COLORBLACK = 133,
  DBGRAPHIC_LIGHT_MOVE = 134,
  DBGRAPHIC_ENLIGHTEN_IRRADIANCE_OFF = 135,
  DBGARPHIC_ENLIGHTEN_SUSPEND = 136,
  DBGARPHIC_ENLIGHTEN_CUBE_OFF = 137,
  DBGARPHIC_ENLIGHTEN_IRRADIANCE_DISP = 138,
  DBGARPHIC_TEXTURE_SHOT_JUMPONLY = 139,
  DBGARPHIC_SKY_LIGHT_OFF = 140,
  DBGARPHIC_ENLIGHTEN_TEXTURE_SHOT2 = 141,
  DBGARPHIC_ENLIGHTEN_CUBEVOLUME_DISP = 142,
  // 143
  DBGRAPHIC_UI_SIMPLE_SHADER = 144,
  // 145
  // 146
  // 147
  // 148
  // 149
  // 150
  // 151
  // 152
  // 153
  // 154
  // 155
  // 156
  // 157
  // 158
  // 159
};

enum class STA_FLAG
{
  STA_PAUSE = 0,
  STA_EVENT = 1,
  STA_SOFT_EVENT = 2,
  STA_EVENT_2MOVE = 3,
  STA_EVENT_2MOVE_DRAW_SKIP_FRAME = 4,
  STA_SUSPEND = 5,
  STA_CONTINUE = 6,
  STA_CREDIT_NO_PLAYABLE = 7,
  STA_MT_BEHEVIOR = 8,
  STA_BUNKER = 9,
  STA_QTE = 10,
  STA_SCRIPT_EVENT_MODE = 11,
  STA_EVENT_CAMERA_LINK = 12,
  // 13
  // 14
  // 15
  STA_HACKING_TRANSITION = 16,
  STA_GALLERY = 17,
  STA_CAPTION = 18,
  STA_SHOOTING = 19,
  STA_SUBSCREEN_DRAW_MODEL = 20,
  STA_PAUSE_CAPTURE = 21,
  STA_LOCAL_AREA_INVALID = 22,
  STA_P200_110_ADAM_NET_OFF = 23,
  STA_FAST_TRAVEL = 24,
  STA_FLAG_DBG_MODE = 25,
  STA_NOVEL = 26,
  STA_DIALOG_PAUSE = 27,
  STA_PAUSE_IMAGE_VIEW = 28,
  STA_CAMERA_LEAVE_PLAYER = 29,
  STA_ENDROLL_SHOOTING = 30,
  STA_MOVIE = 31,
  STA_THREAD_MOVE = 32,
  STA_PAUSE_TUTORIAL = 33,
  STA_SHORTCUT_ITEM = 34,
  STA_ENEMYSET_ROOM = 35,
  STA_PICTUREBOOK_PLAY = 36,
  STA_PAUSE_SKIPCHECK_ONLY = 37,
  STA_MOUSE_CURSOR_ON = 38,
  STA_SAVE_BAN = 39,
  STA_ELEV = 40,
  STA_NOVEL_PLAY = 41,
  STA_HAP_FADEOUT = 42,
  STA_ACDB_BAN = 43,
  // 44
  // 45
  // 46
  // 47
  STA_SEARCH_MODE = 48,
  STA_UI_BUG = 49,
  STA_GAMECENTER = 50,
  STA_EM_NO_ITEM_DORP = 51,
  STA_HAP_AUTO = 52,
  STA_HAP_AUTO_HIGH = 53,
  STA_DATA_DEL_EVENT = 54,
  STA_EM_WAIT = 55,
  // 56
  // 57
  STA_CIWS = 58,
  STA_BUNKER_ELEV = 59,
  STA_PL_NO_DAMAGE = 60,
  STA_EVENT_WINDOW_TALK = 61,
  STA_ACCESS_OBJ = 62,
  STA_KAIJU_STG = 63,
  // 64
  // 65
  // 66
  // 67
  // 68
  // 69
  // 70
  // 71
  // 72
  // 73
  // 74
  // 75
  // 76
  // 77
  // 78
  // 79
  // 80
  // 81
  // 82
  // 83
  // 84
  // 85
  // 86
  // 87
  // 88
  // 89
  // 90
  // 91
  // 92
  // 93
  // 94
  // 95
  // 96
  // 97
  // 98
  // 99
  // 100
  // 101
  // 102
  // 103
  // 104
  // 105
  // 106
  // 107
  // 108
  // 109
  // 110
  // 111
  // 112
  // 113
  // 114
  // 115
  // 116
  // 117
  // 118
  // 119
  // 120
  // 121
  // 122
  // 123
  // 124
  // 125
  // 126
  // 127
};

enum class STOP_FLAG
{
  STP_OBJ = 0,
  STP_PL = 1,
  STP_EM = 2,
  STP_ETCOBJ = 3,
  STP_ESP = 4,
  STP_SCR = 5,
  STP_UI = 6,
  STP_FILTER = 7,
  STP_SHADOW = 8,
  STP_SUBPL = 9,
  STP_PL_KEY = 10,
  STP_PL_MOVE_KEY = 11,
  STP_PL_ATTACK_KEY = 12,
  STP_IK = 13,
  STP_PL_CAM_KEY = 14,
  STP_TRIGGER = 15,
  STP_EVENT_SKIP = 16,
  STP_SCENARIO = 17,
  STP_GAME_UPDATE = 18,
  STP_EM_ATK = 19,
  STP_PL_NO_FACE_MOVE = 20,
  // 21
  // 22
  // 23
  // 24
  // 25
  // 26
  // 27
  // 28
  // 29
  // 30
  // 31
  STP_KEYBOARD_PAD = 32,
  STP_MOUSE_RESTRICTION = 33,
  STP_HAP_PL_KEY = 34,
  // 35
  // 36
  // 37
  // 38
  // 39
  // 40
  // 41
  // 42
  // 43
  // 44
  // 45
  // 46
  // 47
  STP_ESP_COMPUTE_UPADTE = 48,
  STP_ESP_LINECHECK = 49,
  // 50
  // 51
  // 52
  // 53
  // 54
  // 55
  // 56
  // 57
  // 58
  // 59
  // 60
  // 61
  // 62
  // 63
  // 64
  // 65
  // 66
  // 67
  // 68
  // 69
  // 70
  // 71
  // 72
  // 73
  // 74
  // 75
  // 76
  // 77
  // 78
  // 79
  // 80
  // 81
  // 82
  // 83
  // 84
  // 85
  // 86
  // 87
  // 88
  // 89
  // 90
  // 91
  // 92
  // 93
  // 94
  // 95
  // 96
  // 97
  // 98
  // 99
  // 100
  // 101
  // 102
  // 103
  // 104
  // 105
  // 106
  // 107
  // 108
  // 109
  // 110
  // 111
  // 112
  // 113
  // 114
  // 115
  // 116
  // 117
  // 118
  // 119
  // 120
  // 121
  // 122
  // 123
  // 124
  // 125
  // 126
  // 127
};

enum class GRAPHIC_FLAG
{
  // 0
  // 1
  GRAPHIC_DEFERRED = 2,
  // 3
  // 4
  // 5
  // 6
  // 7
  // 8
  GRAPHIC_NO_DOF = 9,
  // 10
  // 11
  GRAPHIC_BLUR_OFF_SYSTEM = 12,
  GRAPHIC_BLUR_OFF_GAME = 13,
  // 14
  GRAPHIC_STOP_3D_DRAW = 15,
  GRAPHIC_SLOW_FILTER_PLAYER = 16,
  GRAPHIC_SLOW_FILTER_ENEMY = 17,
  GRAPHIC_NOUSE_REALTIME_TONEMAP = 18,
  GRAPHIC_NOUSE_FILTER_GRADATION = 19,
  GRAPHIC_MIP_MAX_ON = 20,
  GRAPHIC_SSSSS_MODE = 21,
  GRAPHIC_SHADOWCAST_ENTRY_CHECK = 22,
  // 23
  // 24
  // 25
  // 26
  // 27
  // 28
  // 29
  // 30
  // 31
  GRAPHIC_STP_CAM_VFCUL = 32,
  GRAPHIC_NO_SHW_CAST_CULL = 33,
  GRAPHIC_COMP_CUBE_UPDATE = 34,
  GRAPHIC_NO_CAM_ALPHA = 35,
  GRAPHIC_PREFOGCOLOR_UPDATE = 36,
  GRAPHIC_SHADER_INIT_OVER = 37,
  GRAPHIC_CAM_AUTO_FOCUS = 38,
  GRAPHIC_SSAO_VER2 = 39,
  GRAPHIC_FOWARD_ON = 40,
  GRAPHIC_CRAA_ON = 41,
  GRAPHIC_FXAA_ON = 42,
  GRAPHIC_SMAA_ON = 43,
  GRAPHIC_SSAO_ON = 44,
  GRAPHIC_MIRROR_DRAW = 45,
  GRAPHIC_SHADOW_OFF = 46,
  GRAPHIC_RAIN_MODE = 47,
  GRAPHIC_COMP_CLEAR_BUFF = 48,
  GRAPHIC_SET_UI_RESOLVE_PREVFRAME = 49,
  GRAPHIC_STOP_RESOLVE_PREVFRAME = 50,
  GRAPHIC_DRAW_PREVFRAME = 51,
  GRAPHIC_UI_GAME_CAPTER = 52,
  GRAPHIC_COMP_CLEAR_GBUFFER = 53,
  GRAPHIC_RESOLVE_PREEFFTEXTURE = 54,
  // 55
  // 56
  // 57
  // 58
  // 59
  // 60
  // 61
  // 62
  // 63
  GRAPHIC_DRAW_MOVIE = 64,
  // 65
  // 66
  // 67
  // 68
  // 69
  // 70
  // 71
  // 72
  // 73
  // 74
  // 75
  // 76
  // 77
  // 78
  // 79
  GRAPHIC_COMPUTE_PARTICLE_NO_UPDATE = 80,
  GRAPHIC_COMPUTE_PARTICLE_NO_DRAW = 81,
  GRAPHIC_COMPUTE_PARTICLE_COLLISION = 82,
  GRAPHIC_COMPUTE_PARTICLE_VECTORFIELD = 83,
  GRAPHIC_COMPUTE_PARTICLE_NO_BITONICSORT = 84,
  GRAPHIC_COMPUTE_PARTICLE_NO_FIXEDSORT = 85,
  GRAPHIC_COMPUTE_PARTICLE_RADIXSORT = 86,
  // 87
  // 88
  // 89
  // 90
  // 91
  // 92
  // 93
  GRAPHIC_COMPUTE_ASYNC = 94,
  GRAPHIC_COMPUTE_PARTICLE_RADIXSORT_2 = 95, // note: dupe of RADIXSORT above, added _2 suffix after extracting
  // 96
  // 97
  // 98
  // 99
  // 100
  // 101
  // 102
  // 103
  // 104
  // 105
  // 106
  // 107
  // 108
  // 109
  // 110
  // 111
  // 112
  // 113
  // 114
  // 115
  // 116
  // 117
  // 118
  // 119
  // 120
  // 121
  // 122
  // 123
  // 124
  // 125
  // 126
  // 127
};

enum class DISP_FLAG
{
  DISP_NO_OBJ = 0,
  DISP_NO_PL = 1,
  DISP_NO_EM = 2,
  DISP_NO_ETCOBJ = 3,
  DISP_NO_ESP = 4,
  DISP_NO_SCR = 5,
  DISP_NO_MOVIE = 6,
  DISP_NO_SEAMLESS_MAP = 7,
  // 8
  // 9
  // 10
  DISP_NO_WP = 11,
  DISP_NO_BMOBJ = 12,
  DISP_NO_BAOBJ = 13,
  DISP_NO_BHOBJ = 14,
  // 15
  // 16
  // 17
  // 18
  // 19
  // 20
  // 21
  // 22
  // 23
  // 24
  // 25
  // 26
  // 27
  // 28
  // 29
  // 30
  // 31
  // 32
  // 33
  // 34
  // 35
  // 36
  // 37
  // 38
  // 39
  // 40
  // 41
  // 42
  // 43
  // 44
  // 45
  // 46
  // 47
  // 48
  // 49
  // 50
  // 51
  // 52
  // 53
  // 54
  // 55
  // 56
  // 57
  // 58
  // 59
  // 60
  // 61
  // 62
  // 63
  // 64
  // 65
  // 66
  // 67
  // 68
  // 69
  // 70
  // 71
  // 72
  // 73
  // 74
  // 75
  // 76
  // 77
  // 78
  // 79
  // 80
  // 81
  // 82
  // 83
  // 84
  // 85
  // 86
  // 87
  // 88
  // 89
  // 90
  // 91
  // 92
  // 93
  // 94
  // 95
  // 96
  // 97
  // 98
  // 99
  // 100
  // 101
  // 102
  // 103
  // 104
  // 105
  // 106
  // 107
  // 108
  // 109
  // 110
  // 111
  // 112
  // 113
  // 114
  // 115
  // 116
  // 117
  // 118
  // 119
  // 120
  // 121
  // 122
  // 123
  // 124
  // 125
  // 126
  // 127
};

enum class GAME_FLAG
{
  GAME_CAMERA_UD_REVERSE = 0,
  GAME_CAMERA_RL_REVERSE = 1,
  // 2
  // 3
  // 4
  // 5
  GAME_PLAYER_2BA2 = 6,
  GAME_PLAYER_9SA2 = 7,
  GAME_STOP_PL_ATK_S = 8,
  GAME_STOP_PL_ATK_L = 9,
  GAME_STOP_PL_JUMP = 10,
  GAME_STOP_PL_GUN = 11,
  GAME_STOP_PL_SKILL_A = 12,
  GAME_STOP_PL_SKILL_B = 13,
  GAME_STOP_PL_ESCAPE = 14,
  GAME_STOP_PL_MOVE = 15,
  GAME_PLAYER_FUNNEL = 16,
  GAME_HACKING = 17,
  GAME_PLAYER_9S = 18,
  GAME_PLAYER_A2 = 19,
  GAME_PLAYER_PASCAL = 20,
  GAME_2B_BRINK = 21,
  GAME_FREE_FLIGHT = 22,
  GAME_NPC_PASCAL = 23,
  GAME_PL_WALK_TALK_ONLY = 24,
  GAME_LOADING_LONG = 25,
  GAME_HACKING_HUMANOID = 26,
  GAME_CYBERSPACE_STOP = 27,
  GAME_CYBERSPACE_ATK_STOP = 28,
  GAME_FRIENDLY_FIRE_DISABLE = 29,
  GAME_CYBERSPACE_ATK_START = 30,
  GAME_LOADING_SHORT = 31,
  GAME_LOADING_HACKING = 32,
  GAME_ADAM_QUBE_STOP = 33,
  GAME_STAFFROLL = 34,
  GAME_ADAM_QUBE_MOVE = 35,
  GAME_SAVE_BAN = 36,
  GAME_DLC_UNMOUNT = 37,
  GAME_DLC_UNMOUNT_WAIT = 38,
  // 39
  // 40
  // 41
  // 42
  // 43
  // 44
  // 45
  // 46
  // 47
  // 48
  // 49
  // 50
  // 51
  // 52
  // 53
  // 54
  // 55
  // 56
  // 57
  // 58
  // 59
  // 60
  // 61
  // 62
  // 63
};

// Flags are worked on in each uint32_t 'chunk'
// (as can be seen at eg. NieRAutomata.exe+0x382570)
constexpr uint32_t GetFlagValue(uint32_t flagIndex, uint32_t& offset)
{
  offset = (flagIndex / 32) * 4;
  return 0x80000000 >> (flagIndex & 0x1F);
}
